// OLED displej 1,3" SH1106

// připojení knihovny U8glib
#include "U8glib.h"   // Nástroje → Spravovat knihovny (zkratka Ctrl+Shift+I) → Vyhledat „U8glib" by „oliver”, „v. 1.18.0”  
//https://navody.dratek.cz/docs/texty/0/278/u8glib.zip

// nastavení propojovacích pinů
#define CLK 13    // OLED D0
#define MOSI 11   // OLED D1
#define RES 10    // OLED RES
#define DC 9      // OLED DC
#define CS 8      // OLED CS

// inicializace OLED displeje z knihovny U8glib
U8GLIB_SH1106_128X64 oled(CLK, MOSI, CS, DC, RES);

// proměnná pro uchování času poslední obnovy displeje
long int prepis = 0;

void setup(void) {
  // pro otočení displeje o 180 stupňů
  // stačí odkomentovat řádek níže
  // oled.setRot180();
}

void loop(void) {
  // porovnání uloženého a aktuálního času
  // při rozdílu větším než 100 ms se provede
  // obnovení displeje, čas můžeme nastavit dle potřeby
  if (millis() - prepis > 100) {
    // následující skupina příkazů
    // obnoví obsah OLED displeje
    oled.firstPage();
    do {
      // funkce vykresli vykreslí žádanou obsah
      vykresli();
    } while ( oled.nextPage() );
    // uložení posledního času obnovení
    prepis = millis();
  }

  // zde je místo pro další příkazy pro Arduino

  // volitelná pauza 10 ms pro demonstraci
  // vykonání dalších příkazů
  delay(10);
}
// funkce vykresli pro nastavení výpisu informací na OLED
void vykresli(void) {
  // nastavení písma, toto písmo umožní vypsat
  // přibližně 15x4 znaků
  oled.setFont(u8g_font_unifont);
  // nastavení pozice výpisu v pixelech
  // souřadnice jsou ve tvaru x, y
  // souřadnice 0, 0 je v levém horní rohu
  // OLED displeje, maximum je 128, 64
  oled.setPrintPos(0, 10);
  // výpis textu na zadanou souřadnici
  oled.print("Arduino navody");
  oled.setPrintPos(0, 25);
  oled.print("dratek.cz");
  oled.setPrintPos(0, 40);
  oled.print("Cas od zapnuti:");
  oled.setPrintPos(40, 55);
  oled.print(millis() / 1000);
  oled.print(" vterin");
}
